/*
 * MyGantt JavaScript Library v1.1
 *
 * Copyright 2010, Speed Star
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://www.speed-star1.com
 *
 * Includes jquery-1.4.2.min.js
 * http://sizzlejs.com/
 * Copyright 2010, The Dojo Foundation
 * Released under the MIT, BSD, and GPL Licenses.
 *
 * Includes Sizzle.js
 * http://sizzlejs.com/
 * Copyright 2010, The Dojo Foundation
 * Released under the MIT, BSD, and GPL Licenses.
 *
 * Date: Wed Feb 17 03:54:32 2010 -0900
 */

var mygantt;

if (!mygantt) mygantt = {};

// `[g`HTMLIuWFNg
mygantt.chartAreaObj = null;

// `[g`id
mygantt.chartAreaId  = "";

// `[g̊i[p
mygantt.chartInfo    = {};

// R[h̊i[p
mygantt.recordInfo   = [];

// `[gf[^
mygantt.chartData    = [];

// `[g\ptableIuWFNg̕ێp
mygantt.taskTableObj = null;

// `[g\ptbodyIuWFNg̕ێp
mygantt.taskTbodyObj = null;

// `[g\JnDateIuWFNg
mygantt.calSdateObj = null;

// `[g\Ώۂ̓ti[p
mygantt.dateAll = [];

// ͎̕\
mygantt.blankMark = "<i></i>";

// ݑIĂsԍ
mygantt.selectIdx = -1;

// ReLXgj[IuWFNg̕ێp
mygantt.contextMenu = null;

// ReLXgj[̓e(null̓Zp[^)
mygantt.contextMenuInfo = [["Ɉړ","mygantt.recordUp()"]
                          ,["Ɉړ","mygantt.recordDown()"]
                          ,null
                          ,["ɒǉ","mygantt.recordAddOver()"]
                          ,["ɒǉ","mygantt.recordAddUnder()"]
                          ,["폜","mygantt.recordDel()"]
                          ];

mygantt.mObj  = null;
mygantt.mPreX = null;
mygantt.mObjSdateType = null;
mygantt.mObjSdateType = null;
mygantt.rObj = null;
mygantt.rPreX = 0;

mygantt.objChgDataBox = null;
mygantt.objChgData    = null;

// t̕\`
mygantt.dateFormat = "yyyy/mm/dd";

/**
 * `[g̏
 */
mygantt.initChart = function(chartAreaId, chartInfo, recordInfo, chartData){

	mygantt.chartInfo    = chartInfo;
	mygantt.recordInfo   = recordInfo;
	mygantt.chartData    = chartData;
	mygantt.dateAll      = mygantt.getCalDates();

	window.document.onmousemove   = mygantt.mMove;
	window.document.onclick       = function() { if (mygantt.contextMenu != null) mygantt.contextMenu.style.display = "none"; }

	mygantt.chartAreaId  = chartAreaId;
	mygantt.chartAreaObj = document.getElementById(chartAreaId);

	// e[u쐬
	mygantt.taskTableObj = document.createElement("table");
	mygantt.taskTableObj.className = "mygantt_table";
	mygantt.taskTbodyObj = document.createElement("tbody");

	// e[u`[g`ɒǉ
	mygantt.taskTableObj.appendChild(mygantt.taskTbodyObj);
	mygantt.chartAreaObj.appendChild(mygantt.taskTableObj);
};


/**
 * Kg`[g̏o
 */
mygantt.printChart = function(){

	// f[^ύXpBOX̒ǉ
	mygantt.addChgDataBox();

	// ReLXgj[̒ǉ
	mygantt.addContextMenu();

	// wb_쐬
	mygantt.addHeader();

	// ׍쐬
	mygantt.addDetail();
};

/**
 * Kg`[gďo͂
 */
mygantt.rewriteChart = function(){

	// 폜
	while(mygantt.chartAreaObj.firstChild){
		mygantt.chartAreaObj.removeChild(mygantt.chartAreaObj.firstChild);
	}

	// e[u쐬
	mygantt.taskTableObj = document.createElement("table");
	mygantt.taskTableObj.className = "mygantt_table";
	mygantt.taskTbodyObj = document.createElement("tbody");

	// e[u`[g`ɒǉ
	mygantt.taskTableObj.appendChild(mygantt.taskTbodyObj);
	mygantt.chartAreaObj.appendChild(mygantt.taskTableObj);

	// ďo
	mygantt.printChart();
};

/**
 * Õ`[g\
 */
mygantt.lastMonth = function() {
	var yyyy1    = parseInt(mygantt.chartInfo["sdate"].substring(0,4),10);
	var mm1      = parseInt(mygantt.chartInfo["sdate"].substring(4,6),10);
	var dd1      = mygantt.chartInfo["sdate"].substring(6,8);
	var dateObj1 = mygantt.addMonth(yyyy1,mm1,dd1, -1);
	mygantt.chartInfo["sdate"] = mygantt.getDateText(dateObj1);

	var yyyy2    = parseInt(mygantt.chartInfo["edate"].substring(0,4),10);
	var mm2      = parseInt(mygantt.chartInfo["edate"].substring(4,6),10);
	var dd2      = mygantt.chartInfo["edate"].substring(6,8);
	var dateObj2 = mygantt.addMonth(yyyy2,mm2,dd2, -1);
	mygantt.chartInfo["edate"] = mygantt.getDateText(dateObj2);

	mygantt.dateAll      = mygantt.getCalDates();
	mygantt.calSdateObj  = null;
	mygantt.rewriteChart();
};

/**
 * ̃`[g\
 */
mygantt.nextMonth = function() {
	var yyyy1    = parseInt(mygantt.chartInfo["sdate"].substring(0,4),10);
	var mm1      = parseInt(mygantt.chartInfo["sdate"].substring(4,6),10);
	var dd1      = mygantt.chartInfo["sdate"].substring(6,8);
	var dateObj1 = mygantt.addMonth(yyyy1,mm1,dd1, 1);
	mygantt.chartInfo["sdate"] = mygantt.getDateText(dateObj1);

	var yyyy2    = parseInt(mygantt.chartInfo["edate"].substring(0,4),10);
	var mm2      = parseInt(mygantt.chartInfo["edate"].substring(4,6),10);
	var dd2      = mygantt.chartInfo["edate"].substring(6,8);
	var dateObj2 = mygantt.addMonth(yyyy2,mm2,dd2, 1);
	mygantt.chartInfo["edate"] = mygantt.getDateText(dateObj2);

	mygantt.dateAll      = mygantt.getCalDates();
	mygantt.calSdateObj  = null;
	mygantt.rewriteChart();
};

/**
 * OT̃`[g\
 */
mygantt.lastWeek = function() {

	var yyyy1    = parseInt(mygantt.chartInfo["sdate"].substring(0,4),10);
	var mm1      = parseInt(mygantt.chartInfo["sdate"].substring(4,6),10);
	var dd1      = mygantt.chartInfo["sdate"].substring(6,8);
	var dateObj1 = mygantt.addDay(yyyy1,mm1,dd1, -7);
	mygantt.chartInfo["sdate"] = mygantt.getDateText(dateObj1);

	var yyyy2    = parseInt(mygantt.chartInfo["edate"].substring(0,4),10);
	var mm2      = parseInt(mygantt.chartInfo["edate"].substring(4,6),10);
	var dd2      = mygantt.chartInfo["edate"].substring(6,8);
	var dateObj2 = mygantt.addDay(yyyy2,mm2,dd2, -7);
	mygantt.chartInfo["edate"] = mygantt.getDateText(dateObj2);

	mygantt.dateAll      = mygantt.getCalDates();
	mygantt.calSdateObj  = null;
	mygantt.rewriteChart();
};


/**
 * T̃`[g\
 */
mygantt.nextWeek = function() {

	var yyyy1    = parseInt(mygantt.chartInfo["sdate"].substring(0,4),10);
	var mm1      = parseInt(mygantt.chartInfo["sdate"].substring(4,6),10);
	var dd1      = mygantt.chartInfo["sdate"].substring(6,8);
	var dateObj1 = mygantt.addDay(yyyy1,mm1,dd1, 7);
	mygantt.chartInfo["sdate"] = mygantt.getDateText(dateObj1);

	var yyyy2    = parseInt(mygantt.chartInfo["edate"].substring(0,4),10);
	var mm2      = parseInt(mygantt.chartInfo["edate"].substring(4,6),10);
	var dd2      = mygantt.chartInfo["edate"].substring(6,8);
	var dateObj2 = mygantt.addDay(yyyy2,mm2,dd2, 7);
	mygantt.chartInfo["edate"] = mygantt.getDateText(dateObj2);

	mygantt.dateAll      = mygantt.getCalDates();
	mygantt.calSdateObj  = null;
	mygantt.rewriteChart();
};


/**
 * wb_ǉ
 */
mygantt.addHeader = function(){

	var recordInfo = mygantt.recordInfo;
	var tbody = mygantt.taskTbodyObj;

	// s̍쐬
	var tr    = document.createElement("tr");

	// R[hZN^p̃wb_ǉ
	var selector = document.createElement("th");
	selector.className = "mygantt_selector";
	tr.appendChild(selector);

	var i = 0;
	var calenderTH = null;
	var headerTR = [tr];
	var preColspan = 1;
	for (i in recordInfo) {
		var colSpan = 1;
		if (mygantt.isCalenderArea(i)){
			calenderTH = document.createElement("th");
		} else {
			var headerTitle = (recordInfo[i]["title"]) ? recordInfo[i]["title"] : "";
			var rowNo       = (recordInfo[i]["rowno"]) ? parseInt(recordInfo[i]["rowno"],10) : 1;
			var rowIdx = rowNo - 1;
			if (!headerTR[rowIdx]) {
				headerTR[rowIdx] = document.createElement("tr");
			}

			if (recordInfo[i]["colspan"]) {
				colSpan = recordInfo[i]["colspan"];
			}

			if ((headerTitle != "")&&(preColspan == 1)) {
				var headerTH = document.createElement("th");
				if (recordInfo[i]["rowspan"]) {
					headerTH.rowSpan = recordInfo[i]["rowspan"];
				}
				if (recordInfo[i]["colspan"]) {
					headerTH.colSpan = recordInfo[i]["colspan"];
					headerTH.setAttribute("colSpan", recordInfo[i]["colspan"]);
				} else {
					headerTH.className = "mygantt_col" + i;
				}
				headerTH.innerHTML = headerTitle;
				headerTR[rowIdx].appendChild(headerTH);
			}
		}
		preColspan = colSpan;
	}

	// J_̒ǉ
	if (calenderTH == null) calenderTH = document.createElement("th");
	mygantt.addCalender(calenderTH);
	calenderTH.style.padding = "0px";
	calenderTH.style.margin  = "0px";
	headerTR[0].appendChild(calenderTH);

	selector.rowSpan = headerTR.length;
	calenderTH.rowSpan = headerTR.length;

	// s̒ǉ
	for (i in headerTR) {
		headerTR[i].className = "mygantt_header";
		tbody.appendChild(headerTR[i]);
	}
};


/**
 * ׃GA̒ǉ
 */
mygantt.addDetail = function(){

	var i = 0;
	for (i in mygantt.chartData) {
		mygantt.addTaskData(i, mygantt.chartData[i]);
	}
};


/**
 * ׍s̒ǉ
 */
mygantt.addTaskData = function(i, cols) {

	// e[ubody擾
	var tbody = mygantt.taskTbodyObj;

	// s̍쐬
	var tr       = document.createElement("tr");
	tr.id        = "mygantt_detail" + i;

	// R[hZN^̒ǉ
	var selector = document.createElement("td");
	selector.id  = "mygantt_selector" + i;
	selector.className = "mygantt_selector";
	selector.onclick       = function () { mygantt.selectorOnClick(i) };
	selector.oncontextmenu = function () { return mygantt.selectorOnContextmenu(i); }
	tr.appendChild(selector);

	// ̒ǉ
	var detailTR = [tr];

	var calTd = null;
	var colSpan = 1;
	var j = 0;
	for (j in cols) {

			var td = null;
			var inputType = (mygantt.recordInfo[j]["itype"]) ? mygantt.recordInfo[j]["itype"] : "";
			var rowNo       = (mygantt.recordInfo[j]["rowno"]) ? parseInt(mygantt.recordInfo[j]["rowno"],10) : 1;
			var rowIdx = rowNo - 1;

			// s̍쐬
			if (!detailTR[rowIdx]) {
				detailTR[rowIdx] = document.createElement("tr");
			}

			if (mygantt.isCalenderArea(j)){

				// ^XNo[̍쐬
				td = document.createElement("td");
				calTd = td;

			} else if (inputType.match(/^select/)) {

				// v_E̍쐬
				var optionValues = inputType.replace(/^select\(/,"");
				optionValues = optionValues.replace(/\)$/,"");
				var optionValueAry = optionValues.split(",");
				var k = 0;
				var texts = [];
				var values  = [];
				for (k in optionValueAry) {
					var optVal = optionValueAry[k].split(":");
					var optIdx = texts.length;
					values[optIdx]  = optVal[0];
					texts[optIdx] = (optVal.length > 1) ? optVal[1] : optVal[0];
				}

				td = document.createElement("td");
				var progressObj = document.createElement("select");
				progressObj.id = "";
				progressObj.className = "mygantt_col" + j;
				for (k = 0; k < values.length; k++) {
					progressObj.options[k] = new Option(texts[k], values[k]);
				}
				progressObj.value = parseInt(cols[j],10);
				progressObj.onchange = new Function("mygantt.chgChartData(" + i + "," + j +",this)");

				td.appendChild(progressObj);

			} else if (mygantt.recordInfo[j]["title"]) {

				// x̍쐬
				td = document.createElement("td");
				var textObj = document.createElement("div");
				textObj.id = "task" + i + "_" + mygantt.recordInfo[j]["name"];

				textObj.innerHTML = cols[j];
				if (cols[j] == ""){
					textObj.innerHTML = mygantt.blankMark;
				}
				if (inputType != "") {
					textObj.style.cursor = "pointer";
					textObj.onclick = new Function( "mygantt.dispChgDataBox(this," + i +"," + j + ")" );
				}
				td.appendChild(textObj);
			}

			if (td){
				if (mygantt.recordInfo[j]["rowspan"]) {
					td.rowSpan = mygantt.recordInfo[j]["rowspan"];
				}
				if (mygantt.recordInfo[j]["colspan"]) {
					colSpan = mygantt.recordInfo[j]["colspan"];
//					td.colSpan = mygantt.recordInfo[j]["colspan"];
				}
				td.className = "mygantt_col" + j;
				detailTR[rowIdx].appendChild(td);
			}
	}

	// ^XNo[`p̃Z쐬
	if (!calTd) {
		calTd = document.createElement("td");
		calTd.className = "mygantt_col" + (parseInt(j,10) + 1);
		detailTR[0].appendChild(calTd)
	}
	calTd.style.padding = "0px";
	calTd.className = calTd.className + " ruler" + mygantt.chartInfo["mwidth"];

	calTd.rowSpan = detailTR.length;
	selector.rowSpan = detailTR.length

	// ^XNo[(\)̍쐬Aǉ
	var objTaskArea1 = mygantt.createTaskBar(cols, i, "mygantt_taskbar", "ssdate", "sedate");
	calTd.appendChild(objTaskArea1);

	// ^XNo[()̍쐬Aǉ
	if (mygantt.chartInfo["type"] == "B") {
		var objTaskArea2 = mygantt.createTaskBar(cols, i, "mygantt_jissekibar", "rsdate", "redate");
		calTd.appendChild(objTaskArea2);
	}

	// s̒ǉ
	for (j in detailTR) {
		if (j == 0) {
			detailTR[j].id = "mygantt_detail" + i;
		} else {
			detailTR[j].id = "mygantt_detail" + i + "_" + j;
		}
		detailTR[j].className = "mygantt_detail";
		tbody.appendChild(detailTR[j]);
	}
};

/**
 * ^XNo[̍쐬
 */
mygantt.createTaskBar = function(cols, i, className, sdateType , edateType){

	// ^XNo[̕`ɕKvȏ擾
	var sDate    = mygantt.getColData(cols, sdateType);
	var eDate    = mygantt.getColData(cols, edateType);
	var leftPos   = mygantt.getTaskLeft(sDate);
	var taskW     = mygantt.getTaskWidth(sDate, eDate);

	// ^XNGA`
	var objTaskArea = document.createElement("div");
	objTaskArea.className = className + "_area";
	objTaskArea.onselectstart   = function() { return false; };
	var widthDiv = mygantt.chartInfo["mwidth"] * mygantt.dateAll.length;
	objTaskArea.style.width = widthDiv + "px";
	objTaskArea.style.overflow = "hidden";
	objTaskArea.id = "taskArea" + i;
	var objTask = document.createElement("div");
	objTask.id = "task_" + className + i;
	objTask.className = className;
	objTask.style.position = "relative";
	objTask.style.left  = leftPos + "px";
	objTask.style.width = taskW + "px";
	objTask.onmousedown = function() { mygantt.mDown(this, sdateType, edateType) };
	objTask.onmouseout  = mygantt.mOut;
	objTask.onmouseup   = mygantt.mOut;
	objTaskArea.appendChild(objTask);

	// TCYύXpIuWFNg쐬
	var chgSizeObj = document.createElement("div");
	objTask.style.styleFloat = "left";
	objTask.style.cssFloat   = "left";
	chgSizeObj.id = objTask.id + "R";
	chgSizeObj.style.styleFloat = "left";
	chgSizeObj.style.cssFloat   = "left";
	chgSizeObj.innerHTML = "&nbsp;";
	chgSizeObj.style.width = "20px";
	chgSizeObj.style.position = "relative";
	chgSizeObj.style.left = (leftPos - 8) + "px";
	chgSizeObj.style.top = "0px";
	chgSizeObj.onmouseover = mygantt.rOver;
	chgSizeObj.onmousedown = function () { mygantt.rDown(this, sdateType, edateType) };
	chgSizeObj.onmouseout  = mygantt.rOut;
	chgSizeObj.onmouseup   = mygantt.rUp;
	chgSizeObj.onmousemove = mygantt.rMove;
	objTaskArea.appendChild(chgSizeObj);
	return objTaskArea;
};


/**
 * f[^ύXpeLXgBOXǉ
 */
mygantt.addChgDataBox = function() {
	mygantt.objChgDataBox = document.createElement("input");
	mygantt.objChgDataBox.type = "text";
	mygantt.objChgDataBox.style.position = "absolute";
	mygantt.objChgDataBox.style.display = "none";
	mygantt.objChgDataBox.id = "mygantt_chgdatabox";
	mygantt.chartAreaObj.appendChild(mygantt.objChgDataBox);
};

/**
 * lύXp̃eLXgBOX̕\
 */
mygantt.dispChgDataBox = function(obj, rowIdx, colIdx){
	var x = mygantt.getPosLeft(obj);
	var y = mygantt.getPosTop(obj);
	var colValue = mygantt.chartData[rowIdx][colIdx];
	if (mygantt.recordInfo[colIdx]["itype"] == "datepicker") {
		$("#mygantt_chgdatabox").datepicker($.datepicker.regional['ja']);
		$('#mygantt_chgdatabox').datepicker('option', 'duration', 'fast');
	} else {
		$("#mygantt_chgdatabox").datepicker('destroy');
	}
	mygantt.objChgData = obj;
	mygantt.objChgDataBox.style.left = (x-2) + "px";
	mygantt.objChgDataBox.style.top  = (y-4) + "px";
	mygantt.objChgDataBox.value = colValue;
	mygantt.objChgDataBox.onchange = new Function("mygantt.chgChartData("+rowIdx+","+colIdx+",mygantt.objChgDataBox)");
	mygantt.objChgDataBox.onblur   = function() { mygantt.objChgDataBox.style.display = "none" };
	mygantt.objChgDataBox.style.display = "block";
	mygantt.objChgDataBox.focus();
};

/**
 * l̕ύX
 */
mygantt.chgChartData = function(rowIdx, colIdx, obj){

	var colName  = mygantt.recordInfo[colIdx]["name"];
	var colValue = obj.value;

	var errFlg = false;

/*
	if (colName.match(/.*date$/)){
		try {
			var yyyy = parseInt(colValue.substring(0,4),10);
			var mm   = parseInt(colValue.substring(4,6),10) - 1;
			var dd   = colValue.substring(6,8);
			var objDate = new Date(yyyy , mm, dd);
			if ((objDate == "Invalid Date")||(objDate == "NaN")) {
				errFlg = true;
			}
		} catch (e){
			errFlg = true;
		}
	}
*/

	if (errFlg) {
		if (mygantt.objChgDataBox.style.display == "block") {
			mygantt.objChgDataBox.focus();
		}
	} else {
		mygantt.chartData[rowIdx][colIdx] = colValue;
		if (mygantt.objChgData != null) {
			colValue = mygantt.escapeHtml(colValue);
			colValue = (colValue != "") ? colValue : mygantt.blankMark;
			mygantt.objChgData.innerHTML = colValue;
			mygantt.objChgDataBox.style.display = "none";
		}
		mygantt.objChgData = null;
		if ((mygantt.recordInfo[colIdx]["ftype"] == "ssdate") 
		||  (mygantt.recordInfo[colIdx]["ftype"] == "sedate") 
		||  (mygantt.recordInfo[colIdx]["ftype"] == "rsdate") 
		||  (mygantt.recordInfo[colIdx]["ftype"] == "redate")) {
			// TODO ^XNo[̂ݕύX悤
			mygantt.rewriteChart();
		}
	}
};


/**
 * R[hZN^̃NbN
 */
mygantt.selectorOnClick = function(i){

	// OɑIĂs̐F߂
	if (mygantt.selectIdx >= 0) {
		var preRec = document.getElementById("mygantt_detail" + mygantt.selectIdx);
		preRec.className = "mygantt_detail";
		var subIdx = 1;
		while (true) {
			var subRow = document.getElementById("mygantt_detail" + mygantt.selectIdx + "_" + subIdx);
			if (!subRow) break;
			subRow.className = "mygantt_detail";
			subIdx = subIdx + 1;
		}
	}

	// Is̐FύX
	var selectRec = document.getElementById("mygantt_detail" + i);
	if (i == mygantt.selectIdx) {
		mygantt.selectIdx = -1;
		selectRec.className = "mygantt_detail";
	} else {
		mygantt.selectIdx = i;
		selectRec.className = "mygantt_detail_select";
	}

	// sꍇ͂FύX
	var subIdx = 1;
	while (true) {
		var subRow = document.getElementById("mygantt_detail" + i + "_" + subIdx);
		if (!subRow) break;
		subRow.className = selectRec.className;
		subIdx = subIdx + 1;
	}

};


/**
 * R[hZN^̉ENbN
 */
mygantt.selectorOnContextmenu = function(i){

	if (i == mygantt.selectIdx) {
		mygantt.selectIdx = -1;
	}
	mygantt.selectorOnClick(i);

	// ENbNj|̕\
	mygantt.dispRecordMenu();

	return false;
};

/**
 * ENbNj[̕\
 */
mygantt.dispRecordMenu = function() {
	
	var x = event.clientX;
	var y = event.clientY;
	mygantt.contextMenu.style.display = "block";
	mygantt.contextMenu.style.left = x + "px";
	mygantt.contextMenu.style.top  = y + "px";
}

/**
 * ENbNj[̓o^
 */
mygantt.addContextMenu = function() {

	mygantt.contextMenu = document.createElement("div");
	mygantt.contextMenu.id = "mygantt_contextmenu";

	var i = 0;
	for (i in mygantt.contextMenuInfo) {
		if (mygantt.contextMenuInfo[i] == null){
			var separator = document.createElement("hr");
			mygantt.contextMenu.appendChild(separator);
		} else {
			var menu = document.createElement("a");
			menu.href = "#";
			menu.onclick      = new Function( mygantt.contextMenuInfo[i][1] );
			menu.innerHTML    = mygantt.contextMenuInfo[i][0];
			mygantt.contextMenu.appendChild(menu);
		}
	}

	mygantt.chartAreaObj.appendChild(mygantt.contextMenu);
}


/**
 * s̉擾
 */
mygantt.getRowW = function(){
	return (mygantt.dateAll.length * mygantt.chartInfo.mwidth);
};


/**
 * w肳ꂽԍ^XNo[GÂ̂ǂ肷
 */
mygantt.isCalenderArea = function(idx){
	return (mygantt.recordInfo[idx]["ftype"] == "calender");
};

/**
 * w肳ꂽԍJn\̂̂ǂ肷
 */
mygantt.isSSDate = function(idx){
	return (mygantt.recordInfo[idx]["ftype"] == "ssdate");
};

/**
 * w肳ꂽԍI\̂̂ǂ肷
 */
mygantt.isSEDate = function(idx){
	return (mygantt.recordInfo[idx]["ftype"] == "sedate");
};

/**
 * w肳ꂽԍJnѓ̂̂ǂ肷
 */
mygantt.isRSDate = function(idx){
	return (mygantt.recordInfo[idx]["ftype"] == "rsdate");
};

/**
 * w肳ꂽԍIѓ̂̂ǂ肷
 */
mygantt.isREDate = function(idx){
	return (mygantt.recordInfo[idx]["ftype"] == "redate");
};


/**
 * ̃f[^擾
 */
mygantt.getColData = function(cols, colName){

	var i = 0;
	for (i in mygantt.recordInfo) {
		if (mygantt.recordInfo[i]["ftype"] == colName){
			return cols[i];
		}
	}
	return "";
};

/**
 * ̃f[^ݒ肷
 */
mygantt.setColData = function(cols, colName, data){

	var i = 0;
	for (i in mygantt.recordInfo) {
		if (mygantt.recordInfo[i]["ftype"] == colName){
			cols[i] = data;
		}
	}
};


/**
 * R[hɈړ
 */
mygantt.recordUp = function() {
	if (mygantt.selectIdx <= 0) {
		alert("ړł܂");
	} else {
		var moveIdx = parseInt(mygantt.selectIdx,10) - 1;
		var tmpRec = mygantt.chartData[moveIdx];
		mygantt.chartData[moveIdx] = mygantt.chartData[mygantt.selectIdx];
		mygantt.chartData[mygantt.selectIdx] = tmpRec;
		mygantt.rewriteChart();           // ĕ`
		mygantt.selectorOnClick(moveIdx); // đI
	}
}

/**
 * R[hɈړ
 */
mygantt.recordDown = function() {
	if (mygantt.selectIdx >= (mygantt.chartData.length - 1)) {
		alert("ړł܂");
	} else {
		var moveIdx = parseInt(mygantt.selectIdx,10) + 1;
		var tmpRec = mygantt.chartData[moveIdx];
		mygantt.chartData[moveIdx] = mygantt.chartData[mygantt.selectIdx];
		mygantt.chartData[mygantt.selectIdx] = tmpRec;
		mygantt.rewriteChart();           // ĕ`
		mygantt.selectorOnClick(moveIdx); // đI
	}
}

/**
 * R[h폜
 */
mygantt.recordDel = function() {

	var newChartData = [];
	var i = 0;
	for (i in mygantt.chartData) {
		if (i != mygantt.selectIdx) {
			newChartData[newChartData.length] = mygantt.chartData[i];
		}
	}
	mygantt.selectIdx = -1;
	mygantt.chartData = newChartData;
	mygantt.rewriteChart();           // ĕ`
}


/**
 * R[hɒǉ
 */
mygantt.recordAddOver = function() {

	var newChartData = [];
	var i = 0;
	var addIdx = parseInt(mygantt.selectIdx,10);
	for (i in mygantt.chartData) {
		if (i == addIdx) {
			var newRecord = [];
			var j = 0;
			for (j in mygantt.recordInfo){
				newRecord[j] = "";
			}
			newChartData[newChartData.length] = newRecord;
		}
		newChartData[newChartData.length] = mygantt.chartData[i];
	}
	mygantt.selectIdx = -1;
	mygantt.chartData = newChartData;
	mygantt.rewriteChart();           // ĕ`
}

/**
 * R[hɒǉ
 */
mygantt.recordAddUnder = function() {

	var newChartData = [];
	var i = 0;
	var addIdx = parseInt(mygantt.selectIdx,10) + 1;
	for (i in mygantt.chartData) {
		if (i == addIdx) {
			var newRecord = [];
			var j = 0;
			for (j in mygantt.recordInfo){
				newRecord[j] = "";
			}
			newChartData[newChartData.length] = newRecord;
		}
		newChartData[newChartData.length] = mygantt.chartData[i];
	}
	mygantt.selectIdx = -1;
	mygantt.chartData = newChartData;
	mygantt.rewriteChart();           // ĕ`
}

/**
 * R[hԉɒǉ
 */
mygantt.recordAdd = function() {
	var newRecord = [];
	var j = 0;
	for (j in mygantt.recordInfo){
		newRecord[j] = "";
	}
	mygantt.chartData[mygantt.chartData.length] = newRecord;
//	mygantt.selectIdx = -1;
	mygantt.rewriteChart();           // ĕ`
};

/**
 * f[^submit
 */
mygantt.submit = function(attributes){

	// tH[쐬
	var formObj = document.getElementById("mygantt_form");
	if (!formObj) {
		formObj = document.createElement("form");
		formObj.style.display = "none";
		mygantt.chartAreaObj.appendChild(formObj);
	}

	// tH[̎qvf폜
	while(formObj.firstChild){
		mygantt.chartAreaObj.removeChild(formObj.firstChild);
	}

	// tH[vfǉ
	var i = 0;
	for (i in mygantt.chartData) {
		var rec = mygantt.chartData[i];
		var j = 0;
		for (j in mygantt.recordInfo) {
			if (mygantt.recordInfo[j]["name"]) {
				var colName = mygantt.recordInfo[j]["name"];
				if ((mygantt.chartInfo["recPrefix"])&&(mygantt.chartInfo["recPrefix"]!="")) {
					colName = mygantt.chartInfo["recPrefix"] + "["+i+"]." + colName;
				} else {
					colName = colName + "["+i+"]";
				}
				var inputText = document.createElement("input");
				inputText.type = "text";
				inputText.name  = colName;
				inputText.value = rec[j];
				formObj.appendChild(inputText)
			}
		}
	}

	// tH[̐ݒ
	if (attributes){
		var attName = "";
		for (attName in attributes){
			formObj.setAttribute(attName, attributes[attName]);
		}
	}

	// actionɊ܂܂̎擾postvfւ̕ϊ
	var actionPath = formObj.action;
	var actionAry = actionPath.split("?");
	if (actionAry[1]) {
		formObj.action = actionAry[0];
		var args = actionAry[1].split("&");
		for (i in args){
			var keyVal = args[i].split("=");
			var argObj   = document.createElement("input");
			argObj.type  = "text";
			argObj.name  = keyVal[0];
			argObj.value = (keyVal.length > 1) ? keyVal[1] : "";
			formObj.appendChild(argObj);
		}
	}

	// tH[e𑗐M
	formObj.submit();
}


/**
 * ^XNo[̍ʒu擾
 */
mygantt.getTaskLeft = function(ssDate){

	if ((ssDate == null)||(ssDate == "")) {
		return 0;
	}

	var calSdate = mygantt.chartInfo["sdate"];
	if (mygantt.calSdateObj == null) {
		var yyyy = mygantt.getYear(calSdate);
		var mm   = mygantt.getMonth(calSdate);
		var dd   = mygantt.getDay(calSdate);
		mygantt.calSdateObj = new Date(yyyy , mm - 1, dd);
	}
	var yyyy = mygantt.getYear(ssDate);
	var mm   = mygantt.getMonth(ssDate);
	var dd   = mygantt.getDay(ssDate);
	var sdateObj = new Date(yyyy , mm - 1, dd);
	var dateRange = (sdateObj - mygantt.calSdateObj) / (60*60*24*1000);
	return dateRange * mygantt.chartInfo["mwidth"];
};

/**
 * ^XNo[̕擾
 */
mygantt.getTaskWidth = function(sdate, edate){

	if ((sdate == null)||(sdate == "")||(edate == null)||(edate == "")) {
		return 0;
	}
	if (sdate > edate) {
		return 0;
	}

	var yyyy1 = mygantt.getYear(sdate);
	var mm1   = mygantt.getMonth(sdate);
	var dd1   = mygantt.getDay(sdate);
	var sdateObj = new Date(yyyy1 , mm1 - 1, dd1);

	var yyyy2 = mygantt.getYear(edate);
	var mm2   = mygantt.getMonth(edate);
	var dd2   = mygantt.getDay(edate);

	var edateObj = new Date(yyyy2 , mm2 - 1, dd2);
	var dateRange = (edateObj - sdateObj) / (60*60*24*1000);
	var taskW = (dateRange * mygantt.chartInfo["mwidth"]) + mygantt.chartInfo["mwidth"];
	return taskW;
};

/**
 * J_̒ǉ
 */
mygantt.addCalender = function(calArea){

	var isHeader = true;
	if (arguments.length > 1) {
		isHeader = arguments[1];
	}

	var dateAll = mygantt.dateAll;

	var blockW  = mygantt.chartInfo.mwidth;
	var dateCnt = dateAll.length;

	var table = document.createElement("table");
	table.className = "mygantt_table";
	var tbody = document.createElement("tbody");
	var trYM  = document.createElement("tr");
	var trDD  = document.createElement("tr");

	trYM.className = "ym";
	trDD.className = "dd";

	var i = 0;
	var preYm = "";
	var preYmTH = null;
	var preDdTD = null;
	var monthOfDay = 0;
	for (i = 0; i < dateCnt; i++) {
		var yyyymmdd = dateAll[i];
		var ymdAry = yyyymmdd.split("/");
		var ym   = ymdAry[0] + "N" + ymdAry[1] + "";
		var mm   = ymdAry[1];
		var dd   = ymdAry[2];
		if (ym != preYm) {
			if (preYmTH != null) {
				preYmTH.colSpan = monthOfDay;
				preDdTD.className = "last";
			}
			var thYM = document.createElement("th");
//			thYM.className = "ym";
			thYM.innerHTML = ym;
			trYM.appendChild(thYM);
			preYm = ym;
			preYmTH = thYM;
			monthOfDay = 0;
		}
		var tdDD = document.createElement("td");
		preDdTD = tdDD;
		if (isHeader) {
			tdDD.innerHTML = dd;
		} else {
			tdDD.innerHTML = "&nbsp;";
		}
		tdDD.style.width = (blockW -1) + "px";
		trDD.appendChild(tdDD);
		monthOfDay = monthOfDay + 1;
	}

	if (preYmTH != null) {
		preYmTH.colSpan = monthOfDay;
		preYmTH.className = "last";
	}

	if (isHeader) {
		tbody.appendChild(trYM);
	}
	tbody.appendChild(trDD);
	table.appendChild(tbody);
	table.style.width = (blockW * dateCnt) + "px";
	calArea.appendChild(table);
};

/**
 * J_擾
 */
mygantt.getCalDates = function(){

	var sdate = mygantt.chartInfo["sdate"];
	var edate = mygantt.chartInfo["edate"];

	var yyyy1 = parseInt(sdate.substring(0,4),10);
	var mm1   = parseInt(sdate.substring(4,6),10) - 1;
	var dd1   = sdate.substring(6,8);
	var sdateObj = new Date(yyyy1 , mm1, dd1);
	var time1 = sdateObj.getTime();

	var yyyy2 = parseInt(edate.substring(0,4),10);
	var mm2   = parseInt(edate.substring(4,6),10) - 1;
	var dd2   = edate.substring(6,8);
	var edateObj = new Date(yyyy2 , mm2, dd2);
	var time2 = edateObj.getTime();

	var dateAry = [];
	while (true){
		if ((time2 - time1) < 0) break;
		var yyyy = sdateObj.getFullYear();
		var mm   = sdateObj.getMonth() + 1;
		var dd   = sdateObj.getDate();
		dateAry[dateAry.length] = yyyy + "/" + mm + "/" + dd;
		time1 = time1 + (60*60*24*1000);
		sdateObj.setTime(time1);
	}
	return dateAry;
};

/**
 * ^XNo[NbN̏
 */
mygantt.mDown = function(obj, sdateType, edateType){
	mygantt.mObj = obj;
	mygantt.mPreX = parseInt(event.clientX, 10);
	mygantt.mObjSdateType = sdateType;
	mygantt.mObjEdateType = edateType;
};

/**
 * ^XNo[ړ̏
 */
mygantt.mMove = function(){
	var evt = (arguments[0]) ? arguments[0] : event;
	var nowX = parseInt(evt.clientX,10);
	if (mygantt.mObj != null){
		var moveX = nowX - mygantt.mPreX;
		var chgX = parseInt(mygantt.mObj.style.left) + moveX;
		mygantt.mPreX = nowX;
		mygantt.mObj.style.left = chgX + "px";
		document.getElementById(mygantt.mObj.id + "R").style.left = (chgX - 8) + "px";
	}
};

/**
 * ^XNo[}EXAEg̏
 */
mygantt.mOut = function(){

	if (mygantt.mObj != null){
		var moveRange = (mygantt.chartInfo["mwidth"] * mygantt.chartInfo["mmove"]);
		var nowX = parseInt(mygantt.mObj.style.left,10);              // ̍W
		var chgX = Math.floor(nowX / moveRange) * moveRange;  // TCYPʂɕ␳
		var chgW = parseInt(mygantt.mObj.style.width,10);
		var mod  = (nowX / moveRange) - Math.floor(nowX / moveRange); 
		chgX = (mod > 0.5) ? (chgX + moveRange) : chgX;       // ̔ȏ̕ύXǂŕ␳lC
//		chgX = (chgX < 0) ? 0 : chgX;                         // 0ȉ̏ꍇ0ɕύX
		mygantt.mObj.style.left = chgX + "px";                        // ړ
		document.getElementById(mygantt.mObj.id + "R").style.left = (chgX - 8) + "px";

		// f[^ύX
		var idx  = parseInt((mygantt.mObj.id).replace(/[a-zA-Z_]/g,""),10);
		var startPos = (chgX / mygantt.chartInfo["mwidth"]);
		var endPos   = startPos + (chgW / mygantt.chartInfo["mwidth"]) - 1;
		var sdateObj = mygantt.addDayFromText(mygantt.chartInfo["sdate"], startPos);
		var edateObj = mygantt.addDayFromText(mygantt.chartInfo["sdate"], endPos);
		var sdateType = mygantt.mObjSdateType;
		var edateType = mygantt.mObjEdateType;
		var sdateId = "";
		var edateId = "";
		for (i in mygantt.recordInfo){
			var ftype = mygantt.recordInfo[i]["ftype"];
			if (sdateType == ftype){
				sdateId = mygantt.recordInfo[i]["name"];
			}
			if (edateType == ftype){
				edateId = mygantt.recordInfo[i]["name"];
			}
		}

		// Jn̕ύX
		var sdateLabel = document.getElementById("task"+idx+"_"+sdateId);
		if (sdateLabel) {
			var sdateText = mygantt.getDateText(sdateObj, "/");
			sdateLabel.innerHTML = sdateText;
			mygantt.setColData(mygantt.chartData[idx], sdateType, sdateText);
		}

		// I̕ύX
		var edateLabel = document.getElementById("task"+idx+"_"+edateId);
		if (edateLabel) {
			var edateText = mygantt.getDateText(edateObj, "/");
			edateLabel.innerHTML = edateText;
			mygantt.setColData(mygantt.chartData[idx], edateType, edateText);
		}
	}
	mygantt.mObj = null;
};

/**
 * TCYύXpIuWFNgNbN
 */
mygantt.rDown = function(obj, sdateType, edateType){
	var targetId = (obj.id).replace("R","");
	mygantt.rObj = document.getElementById(targetId);
	mygantt.rPreX = parseInt(event.clientX,10);
	mygantt.rObjSdateType = sdateType;
	mygantt.rObjEdateType = edateType;
};

/**
 * TCYύXpIuWFNgɃ}EXI[o[
 */
mygantt.rOver = function(){
	document.body.style.cursor = "e-resize";
};

/**
 * TCYύXpIuWFNg̃}EXAbv
 */
mygantt.rUp = function(){
	if (mygantt.rObj != null){
		var moveRange = (mygantt.chartInfo["mwidth"] * mygantt.chartInfo["mmove"]);
		var nowW = parseInt(mygantt.rObj.style.width, 10);
		var chgW = Math.floor(nowW / moveRange) * moveRange;         // TCYPʂɕ␳(؎̂)
		var mod = (nowW / moveRange) - Math.floor(nowW / moveRange); 
		chgW = (mod > 0.5) ? (chgW + moveRange) : chgW;              // ̔ȏ̕ύXǂŕ␳lC
		mygantt.rObj.style.width = chgW + "px";                      // ύX

		var chgX = parseInt(mygantt.rObj.style.left,10);

		// f[^ύX
		var idx  = parseInt((mygantt.rObj.id).replace(/[a-zA-Z_]/g,""),10);
		var startPos = (chgX / mygantt.chartInfo["mwidth"]);
		var endPos   = startPos + (chgW / mygantt.chartInfo["mwidth"]) - 1;
		var sdateObj = mygantt.addDayFromText(mygantt.chartInfo["sdate"], startPos);
		var edateObj = mygantt.addDayFromText(mygantt.chartInfo["sdate"], endPos);
		var sdateType = mygantt.rObjSdateType;
		var edateType = mygantt.rObjEdateType;
		var sdateId = "";
		var edateId = "";
		for (i in mygantt.recordInfo){
			var ftype = mygantt.recordInfo[i]["ftype"];
			if (sdateType == ftype){
				sdateId = mygantt.recordInfo[i]["name"];
			}
			if (edateType == ftype){
				edateId = mygantt.recordInfo[i]["name"];
			}
		}

		// Jn̕ύX
		var sdateLabel = document.getElementById("task"+idx+"_"+sdateId);
		if (sdateLabel) {
			var sdateText = mygantt.getDateText(sdateObj, "/");
			sdateLabel.innerHTML = sdateText;
			mygantt.setColData(mygantt.chartData[idx], sdateType, sdateText);
		}

		// I̕ύX
		var edateLabel = document.getElementById("task"+idx+"_"+edateId);
		if (edateLabel) {
			var edateText = mygantt.getDateText(edateObj, "/");
			edateLabel.innerHTML = edateText;
			mygantt.setColData(mygantt.chartData[idx], edateType, edateText);
		}
	}
	mygantt.rObj = null;
};

/**
 * TCYύXpIuWFNg̃}EXAEg
 */
mygantt.rOut = function(){
	mygantt.rUp();
	document.body.style.cursor = "default";
};


/**
 * TCYύXpIuWFNg̃}EXړ
 */
mygantt.rMove = function(){
	var evt = (arguments[0]) ? arguments[0] : event;
	var nowX = parseInt(evt.clientX,10);
	if (mygantt.rObj != null) {
		var w = nowX - mygantt.rPreX;
		var chgW = parseInt(mygantt.rObj.style.width) + w;
		mygantt.rPreX = nowX;
		mygantt.rObj.style.width = chgW + "px";
	}
};


/**
 * HTML̃GXP[v
 */
mygantt.escapeHtml = function(text){
	text = text.replace("&","&amp;");
	text = text.replace("<","&lt;");
	text = text.replace(">","&gt;");
	text = text.replace(" ","&nbsp;");
	return text;
};

/**
 * IuWFNgYW擾
 */
mygantt.getPosTop = function(obj){
	topPos = 0;
	while (true){
		topPos = topPos + obj.offsetTop;
		if (obj.offsetParent) {
			obj = obj.offsetParent;
		} else {
			break;
		}
	}
	return topPos;
};

/**
 * IuWFNgXW擾
 */
mygantt.getPosLeft = function(obj){
	leftPos = 0;
	while (true){
		leftPos = leftPos + obj.offsetLeft;
		if (obj.offsetParent) {
			obj = obj.offsetParent;
		} else {
			break;
		}
	}
	return leftPos;
};


/**
 * n,nO̓t߂
 */
mygantt.addDay = function(year, month, day, addDays) {
	var dateObj = new Date(year, month - 1, day);
	var baseSec = dateObj.getTime();
	var addSec = addDays * 86400000;
	var targetSec = baseSec + addSec;
	dateObj.setTime(targetSec);
	return dateObj;
};

/**
 * n,nO̓t߂
 */
mygantt.addDayFromText = function(dateText, addDays) {

	var yyyy = mygantt.getYear(dateText);
	var mm   = mygantt.getMonth(dateText);
	var dd   = mygantt.getDay(dateText);

	var dateObj = new Date(yyyy, mm - 1, dd);
	var baseSec = dateObj.getTime();
	var addSec = addDays * 86400000;
	var targetSec = baseSec + addSec;
	dateObj.setTime(targetSec);
	return dateObj;
};


/**
 * t𕶎Ŏ擾
 */
mygantt.getDateText = function(dateObj /*, delimiter */) {
	var delimiter = "";
	if (arguments.length > 1) {
		delimiter = arguments[1];
	}
	var yyyy = parseInt(dateObj.getFullYear(),10);
	var mm   = parseInt(dateObj.getMonth()+1,10);
	var dd   = parseInt(dateObj.getDate(),10);
	if (mm < 10) {
		mm = "0" + mm;
	}
	if (dd < 10) {
		dd = "0" + dd;
	}
	return yyyy + delimiter + mm + delimiter + dd;
};

/**
 * NzŎ擾
 */
mygantt.getYmdAry = function(dateText) {
	var yyyy = "";
	var mm   = "";
	var dd   = "";
	if (dateText.match(/^[0-9][0-9][0-9][0-9]\/[0-9]([0-9]|)\/[0-9]([0-9]|)$/)) {
		var dateAry = dateText.split("/");
		yyyy = parseInt(dateAry[0],10);
		mm   = parseInt(dateAry[1],10);
		dd   = parseInt(dateAry[2],10);
	} else {
		yyyy = parseInt(dateText.substring(0,4),10);
		mm   = parseInt(dateText.substring(4,6),10);
		dd   = parseInt(dateText.substring(6,8),10);
	}
	var dateAry = [ yyyy, mm, dd];
	return dateAry;
};

/**
 * N擾
 */
mygantt.getYear = function(dateText) {
	var dateAry = mygantt.getYmdAry(dateText);
	return dateAry[0];
};

/**
 * 擾
 */
mygantt.getMonth = function(dateText) {
	var dateAry = mygantt.getYmdAry(dateText);
	return dateAry[1];
};

/**
 * 擾
 */
mygantt.getDay = function(dateText) {
	var dateAry = mygantt.getYmdAry(dateText);
	return dateAry[2];
};

/**
 * n,nO̓t߂
 */
mygantt.addMonth = function(year, month, day, addMonths) {
	year  = parseInt(year,10);
	month = parseInt(month,10);
	day   = parseInt(day,10);
	month += addMonths;
	var endDay = mygantt.getLastDayOfMonth(year, month);
	if(day > endDay) day = endDay;
	var dateObj = new Date(year, month - 1, day);
	return dateObj;
};


/**
 * ߂
 */
mygantt.getLastDayOfMonth = function(year, month) {
	var dateObj = new Date(year, month, 0);
	return dateObj.getDate();
};

